<?php
namespace Folha\Entities;
/**
 * Class Gpevinculom
 * @package Folha\Entities
 * @method static \Folha\Entities\GpeVinculom findOneByNrvinculomAndNrorg($nrvinculom, $nrorg)
 * @method static \Folha\Entities\GpeVinculom findOneByNrorgAndCdmatricula($nrorg, $cdmatricula)
 */
class GpeVinculom extends Base\GpeVinculom
{

    /**
     * Retorna o ultimo histórico do vínculo com base na data de competencia
     * @param \TkDateTime $competencia Ultimo dia do mes da competencia.
     * @return \Folha\Entities\GpeVinculoh
     * @author francismararaujo 03/01/2014
     */

    public function retornaUltimoHistoricoCompetencia($competencia){

        /** @var $historico \Folha\Repositories\GpeVinculoh */
        $historico = \Folha\Entities\GpeVinculoh::getRepository();
        return $historico->retornaUltimoHistoricoCompetencia($this->getNrorg(), $this->getNrvinculom(), $competencia);

    }

    // LISTA DE MÉTODOS UTILIZADOS EXCLUISIVAMENTE NA MIGRACAO ALINUTRI.
    public static function geraNovoCodigoMigracaoVinculo($nrpessoa, $nrorg)
    {
        $gpevinculom = self::findOneByNrpessoaAndNrorg($nrpessoa, $nrorg);
        if ($gpevinculom instanceof \Folha\Entities\GpeVinculom) {
            $nrvinculom = $gpevinculom->getNrvinculom();
        } else {
            $nrvinculom = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'INTG_GPE_VINCULOM_NRVINCULOM', 1, 10, true);
        }

        return $nrvinculom;
    }

}