/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMP                                                     */
/* Tabela : COMPRADOR                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 22/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_COMP
BEFORE INSERT OR UPDATE OR DELETE
ON COMPRADOR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCOMP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDOPERADOR,0)  <> NVL(:NEW.CDOPERADOR,0))  OR
         (NVL(:OLD.VRLIMAFCOMP,0) <> NVL(:NEW.VRLIMAFCOMP,0)) OR
         (NVL(:OLD.VRLIMAFMES,0)  <> NVL(:NEW.VRLIMAFMES,0)) THEN
         :NEW.DTULTATUCOMP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('COMPRADOR', '', 'CDOPERADOR='||:OLD.CDOPERADOR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE COMPRADOR MODIFY DTULTATUCOMP DEFAULT SYSDATE
/
